<?php

namespace Teknisa\SM\Controller;

use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\Remote\FileUploader\Server;

class FileServerController {
    
    protected $zhFileUploader;
    
    public function __construct(Server $zhFileUploader) {
        $this->zhFileUploader = $zhFileUploader;
    }
    
    public function excluirArquivos(Request\DataSet $request, Response $response) {
        try {
            $rows = $request->getDataSet()->getRows();
            foreach ($rows as $row) {
                if (!empty($row["CAMINHO"])) {
                    $this->zhFileUploader->deleteFile($row["CAMINHO"]);
                }
            }
        }
        catch (\Exception $e) {
            $response->setError(new Response\Error($e->getMessage(), $e->getCode()));
        }
    }
}

?>