CREATE OR REPLACE PROCEDURE CALCULA_PRECO(
  P_IDINDICE        IN VARCHAR DEFAULT 'N', -- 'S' -> D mensagem de erro na ausncia do ndice para o clculo.
  P_CDFILIAL        IN FILIAL.CDFILIAL%TYPE,
  P_CDCIA           IN COMPANHIA.CDCIA%TYPE,
  P_NRVOO           IN VOOTRECHO.NRVOO%TYPE,
  P_CDTRECHO        IN VOOTRECHO.CDTRECHO%TYPE,
  P_CDSERVICO       IN SERVPLANO.CDSERVICO%TYPE,
  P_DTHRPLAVOOPV    IN SERVPLANO.DTHRPLAVOOPV%TYPE,
  P_DTHRABASTPV     IN PLANOVOO.DTHRABASTPV%TYPE,
  P_QTTOTPAX_PAXSBY IN PREVISAOPAX.QTTOTPAXAT%TYPE,
  P_QTSERFATSP      IN SERVPLANO.QTSERFATSP%TYPE,
  P_IDTIPMANUALSP   IN SERVPLANO.IDTIPMANUALSP%TYPE,
  P_VRPRECORRENTE   IN OUT PRECOSECIA.VRPRESERVD%TYPE,
  P_VRPREDOLAR      IN OUT PRECOSECIA.VRPRESERV%TYPE
) AS
  V_TESTE          NUMBER;
  V_NRTABPRECO     TABPRECOSE.NRTABPRECO%TYPE;
  V_IDFATSE        SERVICOCIA.IDFATSE%TYPE;
  V_IDTIPMANUAL    SERVICOCIA.IDTIPMANUAL%TYPE;
  V_QUANTIDADE     SERVPLANO.QTSERFATSP%TYPE;
  V_IDTPPRECO      SERVICOCIA.IDTPPRECO%TYPE;
  V_SGCIA          COMPANHIA.SGCIA%TYPE;
  V_COUNT          NUMBER;
  V_VRPRUDOLSESP   SERVPLANO.VRPRUDOLSESP%TYPE;
  V_VRPRURESESP    SERVPLANO.VRPRURESESP%TYPE;
  V_NRITEMPLANSP   SERVPLANO.NRITEMPLANSP%TYPE;
  V_NRSEQPRECO     PRECOSECIA.NRSEQPRECO%TYPE;
  V_VRINDICE       MOVINDICE.VRINDICE%TYPE;
  V_CDSERVICO      PRODUTO.CDARVPROD%TYPE;
  V_IDCALCPRECPROP PARAMCOMIS.IDCALCPRECPROP%TYPE;
  V_NRDECITOTANF   PARAMGERAL.NRDECITOTANF%TYPE;
  V_IDCALCPROPDLCOM PARAMCOMIS.IDCALCPROPDLCOM%TYPE;
  V_PROP            NUMBER;
  V_1PORPAX         NUMBER;

BEGIN
  SELECT CDARVPROD
  INTO V_CDSERVICO
  FROM PRODUTO
  WHERE
     (CDPRODUTO    = P_CDSERVICO) AND
     (IDPRODCOMISS = '1');


   SELECT COUNT(*)
   INTO V_COUNT
   FROM SERVPLANO
   WHERE (CDFILIAL     = P_CDFILIAL    ) AND
         (CDCIA        = P_CDCIA       ) AND
         (NRVOO        = P_NRVOO       ) AND
         (CDTRECHO     = P_CDTRECHO    ) AND
         (DTHRPLAVOOPV = P_DTHRPLAVOOPV) AND
         (CDSERVICO    = P_CDSERVICO   ) AND
         (IDSITSERSP  <> '3'           );

  BEGIN
     SELECT NVL(NRDECITOTANF, 2)
     INTO V_NRDECITOTANF
     FROM PARAMGERAL
     WHERE
        (CDFILIAL = P_CDFILIAL);
  EXCEPTION
     WHEN No_Data_Found THEN
      V_NRDECITOTANF := NULL;
  END;

  /* testa se possui preo proporcional / calcula proporcionalidade em deliv complementar / no  qt 1 por pax no deve permitir*/
  
   BEGIN
      SELECT NRTABPRECO
            INTO V_NRTABPRECO
            FROM TABPRECOSE
            WHERE (CDFILIAL = P_CDFILIAL) AND
                  (CDCIA    = P_CDCIA)    AND
                  (P_DTHRABASTPV BETWEEN DTINIVIGTAB AND DTFIMVIGTAB);
   EXCEPTION
      WHEN No_Data_Found THEN
       V_NRTABPRECO := NULL;
   END;                  
                  
  SELECT MAX(IDCALCPROPDLCOM)
    INTO V_IDCALCPROPDLCOM
    FROM PARAMCOMIS
   WHERE (CDFILIAL = P_CDFILIAL);


   SELECT COUNT(CDSERVICO)
     INTO V_PROP
     FROM PROPRECOSE
    WHERE (CDFILIAL      = P_CDFILIAL  ) AND
          (CDCIA         = P_CDCIA     ) AND
          (CDSERVICO     = P_CDSERVICO ) and (NRTABPRECO = V_NRTABPRECO);

   SELECT COUNT(CDSERVICO)
     INTO V_1PORPAX
     FROM PADVOOTRE
    WHERE (CDFILIAL      = P_CDFILIAL  ) AND
          (CDCIA         = P_CDCIA     ) AND
          (CDSERVICO     = P_CDSERVICO ) AND
          (NRVOO         = P_NRVOO     ) AND
          (CDTRECHO      = P_CDTRECHO  ) AND
          (IDPROPSEVOO <> '1');

   IF (V_IDCALCPROPDLCOM = 'S') AND (V_PROP > 0) AND (V_1PORPAX > 0) THEN
      V_TESTE := 0;
   ELSE
      V_TESTE := 1;
   END IF;

   IF (V_TESTE = 0) THEN
      Raise_Application_Error(-20501, 'Eser_Prpax'||'                    '||V_CDSERVICO||'*', True);
   END IF;

  IF (V_COUNT > 0) AND (P_QTSERFATSP = 0) THEN
      DBMS_OUTPUT.PUT_LINE(V_COUNT||' - '||P_QTSERFATSP);

      SELECT NRITEMPLANSP,VRPRUDOLSESP,VRPRURESESP
      INTO V_NRITEMPLANSP,V_VRPRUDOLSESP,V_VRPRURESESP
      FROM  SERVPLANO
      WHERE (CDFILIAL     = P_CDFILIAL    ) AND
            (CDCIA        = P_CDCIA       ) AND
            (NRVOO        = P_NRVOO       ) AND
            (CDTRECHO     = P_CDTRECHO    ) AND
            (DTHRPLAVOOPV = P_DTHRPLAVOOPV) AND
            (CDSERVICO    = P_CDSERVICO   ) AND
            (IDSITSERSP  <> '3'           ) AND
            (NRITEMPLANSP = (SELECT MIN(NRITEMPLANSP)
                             FROM  SERVPLANO
                             WHERE (CDFILIAL     = P_CDFILIAL    ) AND
                                   (CDCIA        = P_CDCIA       ) AND
                                   (NRVOO        = P_NRVOO       ) AND
                                   (CDTRECHO     = P_CDTRECHO    ) AND
                                   (DTHRPLAVOOPV = P_DTHRPLAVOOPV) AND
                                   (CDSERVICO    = P_CDSERVICO   ) AND
                                   (IDSITSERSP  <> '3'           )));

      P_VRPRECORRENTE := V_VRPRURESESP;
      P_VRPREDOLAR    := V_VRPRUDOLSESP;

   ELSE
      SELECT MAX(SGCIA)
      INTO   V_SGCIA
      FROM   COMPANHIA
      WHERE  CDCIA = P_CDCIA;

      SELECT IDFATSE, IDTIPMANUAL,  IDTPPRECO
      INTO   V_IDFATSE, V_IDTIPMANUAL,V_IDTPPRECO
      FROM   SERVICOCIA
      WHERE  CDSERVICO = P_CDSERVICO;

      BEGIN
         SELECT NVL(IDCALCPRECPROP, '1')
         INTO V_IDCALCPRECPROP
         FROM PARAMCOMIS
         WHERE
           (CDFILIAL = P_CDFILIAL);
      EXCEPTION
         WHEN No_Data_Found THEN
            V_IDCALCPRECPROP := NULL;
      END;

       /* INCLUDO POR LUCIANA DIA 14/06/2000 A PEDIDO DO SR. JULIANO GUERRA E RODRIGO */
       /* PARAMETRO CRIADO PARA CALCULO DE SERVICO COM PRECO PROPORCIONAL COM O PRECO TOTAL MARCADO */
      IF ((V_IDTPPRECO = '2') AND (V_IDCALCPRECPROP = '1')) THEN     /* PRECO TOTAL */
        V_QUANTIDADE := P_QTTOTPAX_PAXSBY;
      ELSE
        V_QUANTIDADE := P_QTSERFATSP;
      END IF;

      IF P_IDTIPMANUALSP IS NOT NULL THEN
         V_IDTIPMANUAL := P_IDTIPMANUALSP;
      END IF;

      IF V_IDFATSE = '1' THEN
      
         BEGIN
            SELECT COUNT(*)
            INTO V_TESTE
            FROM TABPRECOSE
            WHERE (CDFILIAL = P_CDFILIAL) AND
                  (CDCIA    = P_CDCIA   ) AND
                  (P_DTHRABASTPV BETWEEN DTINIVIGTAB AND DTFIMVIGTAB);
         EXCEPTION
            WHEN No_Data_Found THEN
             V_TESTE := NULL;
         END;       
         IF (V_TESTE > 1) THEN
               Raise_Application_Error(-20501, '#EVoo_valta'||'     '||V_SGCIA||'*', True);
         END IF;
         

         IF (V_TESTE = 1) THEN
            BEGIN
               SELECT NRTABPRECO
               INTO V_NRTABPRECO
               FROM TABPRECOSE
               WHERE (CDFILIAL = P_CDFILIAL) AND
                     (CDCIA    = P_CDCIA)    AND
                     (P_DTHRABASTPV BETWEEN DTINIVIGTAB AND DTFIMVIGTAB);
         EXCEPTION
            WHEN No_Data_Found THEN
             V_NRTABPRECO := NULL;
         END;                   

            SELECT COUNT(NRSEQPRECO),MIN(NRSEQPRECO),
                   NVL(MIN(VRPRESERV),0),NVL(MIN(VRPRESERVD),0)
            INTO V_TESTE,V_NRSEQPRECO,P_VRPRECORRENTE,P_VRPREDOLAR
            FROM PRECOSECIA
            WHERE (CDFILIAL   = P_CDFILIAL  ) AND
                  (CDCIA      = P_CDCIA     ) AND
                  (NRTABPRECO = V_NRTABPRECO) AND
                  (CDSERVICO  = P_CDSERVICO ) AND
                  ((DTINIVIGSE <= P_DTHRABASTPV) OR
                   ((DTINIVIGSE IS NULL) AND
                    (NOT EXISTS (SELECT NRSEQPRECO
                                 FROM PRECOSECIA
                                 WHERE (CDFILIAL    = P_CDFILIAL    ) AND
                                       (CDCIA       = P_CDCIA       ) AND
                                       (NRTABPRECO  = V_NRTABPRECO  ) AND
                                       (CDSERVICO   = P_CDSERVICO   ) AND
                                       (DTINIVIGSE <= P_DTHRABASTPV))))) AND
                  ((DTFIMVIGSE >= P_DTHRABASTPV) OR
                   ((DTFIMVIGSE IS NULL) AND
                    (NOT EXISTS (SELECT NRSEQPRECO
                                 FROM PRECOSECIA
                                 WHERE (CDFILIAL    = P_CDFILIAL    ) AND
                                       (CDCIA       = P_CDCIA       ) AND
                                       (NRTABPRECO  = V_NRTABPRECO  ) AND
                                       (CDSERVICO   = P_CDSERVICO   ) AND
                                       (DTFIMVIGSE >= P_DTHRABASTPV )))));

            IF (V_TESTE > 1) THEN
               Raise_Application_Error(-20501, 'Eser_Preco'||'                    '||V_CDSERVICO||'*', True);
               
            ELSIF (V_TESTE = 1) THEN
               SELECT COUNT(*)
               INTO V_TESTE
               FROM PROPRECOSE
               WHERE (CDFILIAL   = P_CDFILIAL  ) AND
                     (CDCIA      = P_CDCIA     ) AND
                     (NRTABPRECO = V_NRTABPRECO) AND
                     (CDSERVICO  = P_CDSERVICO ) AND
                     (NRSEQPRECO = V_NRSEQPRECO) AND
                     (V_QUANTIDADE BETWEEN QTPAXINICIAL AND QTPAXFINAL);

               IF (V_TESTE > 1) THEN
                  Raise_Application_Error(-20501, '#Evoo_Inter'||'     '||V_SGCIA||'*', True);
               END IF;

               /* Testa se no achou preo para o intervalo informado mas achou para outro intervalo */
               IF (V_TESTE = 0) THEN
                  SELECT COUNT(*)
                  INTO V_TESTE
                  FROM PROPRECOSE
                  WHERE (CDFILIAL   = P_CDFILIAL  ) AND
                        (CDCIA      = P_CDCIA     ) AND
                        (NRTABPRECO = V_NRTABPRECO) AND
                        (CDSERVICO  = P_CDSERVICO ) AND
                        (NRSEQPRECO = V_NRSEQPRECO);
                  IF (V_TESTE > 0) THEN
                     Raise_Application_Error(-20501, 'Eser_Prepr'||'                    '||V_CDSERVICO||'*', True);

                  END IF;
               END IF;

               IF (V_TESTE = 1) THEN
                  SELECT VRPRESERPRO, VRPRESERDPRO
                  INTO P_VRPRECORRENTE, P_VRPREDOLAR
                  FROM PROPRECOSE
                  WHERE (CDFILIAL   = P_CDFILIAL  ) AND
                        (CDCIA      = P_CDCIA     ) AND
                        (NRTABPRECO = V_NRTABPRECO) AND
                        (CDSERVICO  = P_CDSERVICO ) AND
                        (NRSEQPRECO = V_NRSEQPRECO) AND
                        (V_QUANTIDADE BETWEEN QTPAXINICIAL AND QTPAXFINAL);
               END IF;
            END IF;
         END IF;

         IF (P_VRPRECORRENTE IS NULL) THEN
           P_VRPRECORRENTE:= 0;
         END IF;
         IF (P_VRPREDOLAR    IS NULL) THEN
           P_VRPREDOLAR   := 0;
         END IF;

         /* Testa se h indice cadastrado para o dia*/
         SELECT NVL(MIN(MI.VRINDICE),0)
         INTO V_VRINDICE
         FROM PARAMGERAL PA, MOVINDICE MI
         WHERE (MI.CDTPINDICE(+) = '1'   ) AND
               (MI.IDPERVALOR(+) = '2'   ) AND
               (MI.CDINDICE  (+) = '0002') AND
               (MI.DTREFIND  (+) = P_DTHRABASTPV);

         IF (P_VRPRECORRENTE =0) and (P_VRPREDOLAR = 0) then
            Raise_Application_Error(-20501, 'Eser_PreDa'||'                    '||V_CDSERVICO||'*', True);

         END IF;

         IF V_IDTIPMANUAL = '1'  THEN
            IF P_VRPRECORRENTE = 0 THEN
               IF V_VRINDICE <> 0 THEN
                   P_VRPRECORRENTE := P_VRPREDOLAR * V_VRINDICE;
               ELSIF P_IDINDICE = 'S' THEN
                  Raise_Application_Error(-20501, 'Eser_IndFi'||'                    '||V_CDSERVICO||'*', True);

               END IF;
            ELSE
                P_VRPREDOLAR := 0; /* Zerar preo em dlar para servios nacionais apenas qdo o preo em real no for calculado com base nele */
            END IF;
         ELSE
            IF P_VRPREDOLAR = 0 THEN
               IF V_VRINDICE <> 0 THEN
                   P_VRPREDOLAR := P_VRPRECORRENTE / V_VRINDICE;
               ELSIF P_IDINDICE = 'S' THEN
                  Raise_Application_Error(-20501, 'Eser_CAdRe'||'                    '||V_CDSERVICO||'*', True);
               END IF;
            ELSE
               P_VRPRECORRENTE := 0; /* Zerar preo em real sempre para servios internacionais */
            END IF;
         END IF;

      ELSE /* JOGA PRECO ZERO PARA SERVICOS DO TIPO NO FATURADO */
         P_VRPRECORRENTE:= 0;
         P_VRPREDOLAR   := 0;
      END IF;
   END IF;

   IF (V_NRDECITOTANF = 0) THEN
      P_VRPRECORRENTE := ROUND(P_VRPRECORRENTE, 0);
   END IF;
END;
/


-- VERSAO --
BEGIN ATUVEROBJ('CALCULA_PRECO','4.07.xxx'); END;
/


